final float margin_to_left = 160;
final float margin_to_top = 40;

Table overall_data;
int rows, cols; 
int bk_c, cd_c, dvd_c, vhs_c, copies; //copies
int center_w, center_h, diameter;
int bk_n, cd_n, dvd_n, vhs_n;
float bk_r, cd_r, dvd_r, vhs_r; //ratio
float bk_s, cd_s, dvd_s, vhs_s; //start and finish
String[] itemType;
float[] itemNumber;
float[] count;

float temp, temp2, tc, x1, y1, xcount, ycount;
float textwidth;

float max, min, total, mean;
float cell_width, cell_height;

void setup() {
  size(displayWidth, displayHeight);
  overall_data = loadTable("xCatCF_SeattlePublicLibrary.csv", "header");
  rows = overall_data.getRowCount(); 
  cols = overall_data.getColumnCount();

  println("Rows: " + rows);
  println("Columns: " + cols);

  itemType = new String[rows];
  itemNumber = new float[rows];
  count = new float[rows];
  total = 0;
  min = 1;
  max = 0;

  bk_c = 115; 
  cd_c = 33; 
  dvd_c = 173; 
  vhs_c = 10;
  copies = bk_c + cd_c + dvd_c + vhs_c;
  bk_r = (float)bk_c/copies;
  cd_r = (float)cd_c/copies;
  dvd_r = (float)dvd_c/copies;
  vhs_r = (float)vhs_c/copies;

  //[0][0] is actually first element of matrix
  for (int i=0; i<rows; i++) {
    itemType[i] = overall_data.getString(i, 0);
    itemNumber[i] = overall_data.getFloat(i, 1);
    count[i] = overall_data.getFloat(i, 2); //2 is the 3rd column
    total += count[i];

    if (count[i] > max) {
      max = count[i];
    }
  }

  mean = total/copies;
}

//Refresh the canvas every frame
void draw() {  
  background(5);
  strokeCap(ROUND);

  center_w = (displayWidth/2)+250;
  center_h = displayHeight/2;
  diameter = displayWidth/5;

  bk_s = 0; 
  cd_s = TWO_PI*bk_r;
  dvd_s = TWO_PI*(bk_r+cd_r);
  vhs_s = TWO_PI*(bk_r+cd_r+dvd_r);

  textAlign(CENTER, TOP);
  rectMode(CORNER);
  temp = center_h+150; //adjust left padding of text
  temp2 = 150; //adjusts height of text

  fill(255);
  textSize(32);
  text("Charlie and the Chocolate Factory: Number of Checkouts by Item Type", center_w-250, 10);

  textSize(14);
  noFill();

  strokeWeight(1);
  stroke(199, 65, 252);
  ellipseMode(CENTER);
  ellipse(center_w, center_h, diameter+(2*max), diameter+(2*max));
  fill(199, 65, 252);
  text("max", temp2, temp);
  text(int(max) + " checkouts", temp2+90, temp);
  noFill();
  ellipse(temp2+170, temp+10, 20, 20);

  stroke(103, 221, 229);
  ellipseMode(CENTER);
  ellipse(center_w, center_h, diameter+(2*mean), diameter+(2*mean));
  fill(103, 221, 229);
  text("average", temp2, temp+30);
  text((str(int(mean)) + " checkouts"), temp2+90, temp+30);
  noFill();
  ellipse(temp2+170, temp+40, 10, 10);

  stroke(242, 193, 140);
  ellipseMode(CENTER);
  ellipse(center_w, center_h, diameter+(2*count[115]), diameter+(2*count[115]));
  fill(242, 193, 140);
  text("median", temp2, temp+60);
  text(int(count[115]) + " checkouts", temp2+90, temp+60);
  noFill();
  ellipse(temp2+170, temp+70, 8, 8);

  ellipseMode(CENTER);

  noStroke();

  temp= 150;
  textSize(24);
  fill(200);
  text("Data", temp2+125, temp-60);

  textSize(14);

  fill(80, 119, 196); //blue
  arc(center_w, center_h, diameter, diameter, bk_s, cd_s, PIE);
  text("books", temp2, temp);
  text("34.7%", temp2+50, temp);
  text("115 copies", temp2+125, temp);
  rect(temp2+170, temp, bk_r*250, 15);

  fill(340, 230, 115); //yellow
  arc(center_w, center_h, diameter, diameter, cd_s, dvd_s, PIE);
  text("cds", temp2, temp+30);
  text("10.0%", temp2+50, temp+30);
  text("33 copies", temp2+125, temp+30);
  rect(temp2+170, temp+30, cd_r*250, 15);

  fill(242, 91, 77); //red
  arc(center_w, center_h, diameter, diameter, dvd_s, vhs_s, PIE);
  text("dvds", temp2, temp+60);
  text("52.3%", temp2+50, temp+60);
  text("173 copies", temp2+125, temp+60);
  rect(temp2+170, temp+60, dvd_r*250, 15);

  fill(80, 196, 90); //green
  arc(center_w, center_h, diameter, diameter, vhs_s, TWO_PI, PIE);
  text("vhs", temp2, temp+90);
  text("3.0%", temp2+50, temp+90);
  text("10 copies", temp2+125, temp+90);
  rect(temp2+170, temp+90, vhs_r*250, 15);

  //book lines
  temp = cd_s/bk_c;
  bk_n = 0;
  cd_n = 0;
  dvd_n = 0;
  vhs_n = 0;
  for (int i=0; i<bk_c; i++) {
    x1 = (diameter/2)*cos(temp*i)+center_w;
    y1 = (diameter/2)*sin(temp*i)+center_h;
    xcount = ((diameter/2)+(count[i+173+10+33]))*cos(temp*i)+center_w;
    ycount = ((diameter/2)+(count[i+173+10+33]))*sin(temp*i)+center_h;
    stroke(70, 100, 175);
    strokeWeight(2);
    line(x1, y1, xcount, ycount);
    bk_n += count[i+173+10+33];
  }

  //cd lines
  temp = (dvd_s-cd_s)/cd_c;
  for (int i=0; i<cd_c; i++) {
    x1 = (diameter/2)*cos(temp*(i)+cd_s)+center_w;
    y1 = (diameter/2)*sin(temp*(i)+cd_s)+center_h;
    xcount = ((diameter/2)+(count[i+173+10]))*cos(temp*(i)+cd_s)+center_w;
    ycount = ((diameter/2)+(count[i+173+10]))*sin(temp*(i)+cd_s)+center_h;
    stroke(230, 225, 113);
    strokeWeight(2);
    line(x1, y1, xcount, ycount);
    cd_n += count[i+173+10];
  }


  //dvd lines
  temp = (vhs_s-dvd_s)/dvd_c;
  for (int i=0; i<dvd_c; i++) {
    x1 = (diameter/2)*cos(temp*(i)+dvd_s)+center_w;
    y1 = (diameter/2)*sin(temp*(i)+dvd_s)+center_h;
    xcount = ((diameter/2)+(count[i+10]))*cos(temp*(i)+dvd_s)+center_w;
    ycount = ((diameter/2)+(count[i+10]))*sin(temp*(i)+dvd_s)+center_h;
    stroke(230, 85, 70);
    strokeWeight(2);
    line(x1, y1, xcount, ycount);
    dvd_n += count[i+10];
  }

  //vhs lines
  temp = (TWO_PI-vhs_s)/vhs_c;
  for (int i=0; i<vhs_c; i++) {
    x1 = (diameter/2)*cos(temp*(i)+vhs_s)+center_w;
    y1 = (diameter/2)*sin(temp*(i)+vhs_s)+center_h;
    xcount = ((diameter/2)+(count[i]))*cos(temp*(i)+vhs_s)+center_w;
    ycount = ((diameter/2)+(count[i]))*sin(temp*(i)+vhs_s)+center_h;
    stroke(75, 180, 80);
    strokeWeight(2);
    line(x1, y1, xcount, ycount);
    vhs_n += count[i];
  }

  temp= center_h;
  noStroke();
  textSize(24);
  fill(200);
  text("Analysis", temp2+125, temp-60);

  textSize(14);

  fill(80, 119, 196); //blue
  text("books", temp2, temp);
  text("39.2%", temp2+50, temp);
  text(str(bk_n) + " c/o", temp2+125, temp);
  rect(temp2+170, temp, bk_n/35, 15);

  fill(340, 230, 115); //yellow
  text("cds", temp2, temp+30);
  text("13.2%", temp2+50, temp+30);
  text(str(cd_n) + " c/o", temp2+125, temp+30);
  rect(temp2+170, temp+30, cd_n/35, 15);

  fill(242, 91, 77); //red
  text("dvds", temp2, temp+60);
  text("46.6%", temp2+50, temp+60);
  text(str(dvd_n) + " c/o", temp2+125, temp+60);
  rect(temp2+170, temp+60, dvd_n/35, 15);

  fill(80, 196, 90); //green
  text("vhs", temp2, temp+90);
  text("1.0%", temp2+50, temp+90);
  text(str(vhs_n) + " c/o", temp2+125, temp+90);
  rect(temp2+170, temp+90, vhs_n/35, 15);
}